From 990eb3cf82ca88c91682d00e85ea1f74672c5e89 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 21:26:54 +0000
Subject: [PATCH 1588/2232] Test Debug impls


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 41f129a..0d96038 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -15,7 +15,7 @@ use std::os::raw::c_char;
 
 #[cxx::bridge(namespace = "tests")]
 pub mod ffi {
-    #[derive(Clone)]
+    #[derive(Clone, Debug)]
     struct Shared {
         z: usize,
     }
@@ -24,6 +24,7 @@ pub mod ffi {
         msg: String,
     }
 
+    #[derive(Debug)]
     enum Enum {
         AVal,
         BVal = 2020,
diff --git a/tests/test.rs b/tests/test.rs
index b4c39fa..1b9a88e 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -227,6 +227,13 @@ fn test_enum_representations() {
     assert_eq!(2021, ffi::Enum::CVal.repr);
 }
 
+#[test]
+fn test_debug() {
+    assert_eq!("Shared { z: 1 }", format!("{:?}", ffi::Shared { z: 1 }));
+    assert_eq!("BVal", format!("{:?}", ffi::Enum::BVal));
+    assert_eq!("Enum(9)", format!("{:?}", ffi::Enum { repr: 9 }));
+}
+
 #[no_mangle]
 extern "C" fn cxx_test_suite_get_box() -> *mut R {
     Box::into_raw(Box::new(R(2020usize)))

